
<?php
/*
Plugin Name: Shortcode to show a list of the sites's authors
Plugin URI: http://iworks.pl/
Description: Use shortcode [iworks-authors] to create authors list. Avaialable options - orderby, order (look get_users function), gravatar (1|0) and gravatar_size in px.
Version: trunk
Author: Marcin Pietrzak
Author URI: http://iworks.pl/
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

/*

Copyright 2012 Marcin Pietrzak (marcin@iworks.pl)

this program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 */

add_shortcode( 'iworks-authors', 'iworks_authors_shortcode' );

function iworks_authors_shortcode( $atts )
{
    extract( shortcode_atts( array(
        'orderby'       => 'name',
        'order'         => 'ASC',
        'gravatar'      => 1,
        'gravatar_size' => 64
    ), $atts ) );

    $args = array(
        'orderby' => $orderby,
        'order'   => $order,
    );

    $authors = get_users( $args );

    if ( empty( $authors ) ) {
        return '';
    }

    $content = '<ol class="authors">';
    $one = '<li class="name_%s">%s<a href="%s" class="author">%s</a></li>';
    foreach ( $authors as $author ) {
        $content .= sprintf(
            $one,
            apply_filters( 'sanitize_title', $author->user_login ),
            $gravatar? get_avatar( $author->ID, $gravatar_size ).' ': '',
            get_author_posts_url( $author->ID ),
            $author->display_name
        );
    }
    $content .= '</ol>';
    return $content;
}

